import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;

/**
 * Ein Bett, das manipuliert werden kann und sich selbst auf einer Leinwand
 * zeichnet.
 * 
 * @author Claus Albowski
 * @version 2.3 (sept 07)
 */
public class Bed extends Furniture {
    private static final long serialVersionUID = 1L;

    /**
     * Erzeuge ein neues Bett mit einer Standardfarbe und Standardgroesse an einer
     * Standardposition. (Standardkonstruktor)
     */
    public Bed() {
        xPosition = 10;
        yPosition = 180;
        color = Color.magenta;
        orientation = 0;
        isVisible = false;
        width = 200;
        depth = 200;
    }

    /**
     * Erzeuge ein neues Bett.
     */
    public Bed(int xPosition, int yPosition, Color color, int orientation, int width, int depth) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.color = color;
        this.currentColor = color; // the default color is set to the initial color
        this.defaultColor = color; // the default color is set to the initial color
        this.defaultWidth = width; // the default width is set to the initial width
        this.defaultDepth = depth; // the default width is set to the initial depth
        this.orientation = orientation;
        isVisible = false;
        this.width = width;
        this.depth = depth;
    }

    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten [ Zum Anzeigen
     * der Attributwerte ueber Inspect muss hier die Sichtbarkeit auf public gesetzt
     * werden. ]
     */
    protected Shape getCurrentFigure() {
        // einen GeneralPath definieren
        GeneralPath bed = new GeneralPath();
        Rectangle2D frame = new Rectangle2D.Double(0, 0, width, depth);
        bed.append(frame, false);
        Line2D fold1 = new Line2D.Double(0, 0, width, depth / 2);
        bed.append(fold1, false);
        Line2D mid = new Line2D.Double(0, depth / 2, width, depth / 2);
        bed.append(mid, false);
        Line2D fold2 = new Line2D.Double(0, depth, width, depth / 2);
        bed.append(fold2, false);
        return transform(bed);
    }
}
