import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.GeneralPath;

/**
 * Ein Stuhl, der manipuliert werden kann und sich selbst auf einer Leinwand
 * zeichnet.
 * 
 * @author Claus Albowski
 * @version 2.3 (sept 07)
 */
public class Chair extends Furniture {
    private static final long serialVersionUID = 1L;

    /**
     * Erzeuge einen neuen Stuhl mit einer Standardfarbe und Standardgroesse an
     * einer Standardposition. (Standardkonstruktor)
     */
    public Chair() {
        xPosition = 60;
        yPosition = 80;
        orientation = 270;
        color = Color.blue;
        isVisible = false;
        width = 40;
        depth = 40;
    }

    /**
     * Erzeuge einen neuen Stuhl mit einer Standardgroesse.
     */
    public Chair(int xPosition, int yPosition, Color color, int orientation) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.color = color;
        this.currentColor = color; // the default color is set to the initial color
        this.defaultColor = color; // the default color is set to the initial color
        this.orientation = orientation;
        isVisible = false;
        width = 40;
        depth = 40;
        this.defaultWidth = width; // the default width is set to the initial width
        this.defaultDepth = depth; // the default width is set to the initial depth
    }

    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten [ Zum Anzeigen
     * der Attributwerte ueber Inspect muss hier die Sichtbarkeit auf public gesetzt
     * werden. ]
     */
    protected Shape getCurrentFigure() {
        // einen GeneralPath definieren
        GeneralPath chair = new GeneralPath();
        chair.moveTo(0, 0);
        chair.lineTo(width, 0);
        chair.lineTo(width + (width / 20 + 1), depth);
        chair.lineTo(-(width / 20 + 1), depth);
        chair.lineTo(0, 0);
        // Das ist die Umrandung. Das Stuhl bekommt noch eine Lehne:
        chair.moveTo(0, (width / 10 + 1));
        chair.lineTo(width, (width / 10 + 1));
        return transform(chair);
    }

}
