import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;

/**
 * Ein Schrank, der manipuliert werden kann und sich selbst auf einer Leinwand
 * zeichnet.
 * 
 * @author Claus Albowski
 * @version 2.3 (sept 07)
 */
public class Closet extends Furniture {

    private static final long serialVersionUID = 1L;

    /**
     * Erzeuge einen neuen Schrank mit einer Standardfarbe und Standardgroesse an
     * einer Standardposition. (Standardkonstruktor)
     */
    public Closet() {
        xPosition = 10;
        yPosition = 10;
        color = Color.yellow;
        orientation = 0;
        isVisible = false;
        width = 60;
        depth = 37;
    }

    /**
     * Erzeuge einen neuen Schrank.
     */
    public Closet(int xPosition, int yPosition, Color color, int orientation, int width, int depth) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.color = color;
        this.currentColor = color; // the default color is set to the initial color
        this.defaultColor = color; // the default color is set to the initial color
        this.defaultWidth = width; // the default width is set to the initial width
        this.defaultDepth = depth; // the default width is set to the initial depth
        this.orientation = orientation;
        isVisible = false;
        this.width = width;
        this.depth = depth;
    }

    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten [ Zum Anzeigen
     * der Attributwerte ueber Inspect muss hier die Sichtbarkeit auf public gesetzt
     * werden. ]
     */
    protected Shape getCurrentFigure() {
        // einen GeneralPath definieren
        GeneralPath schrank = new GeneralPath();
        Rectangle2D rahmen = new Rectangle2D.Double(0, 0, width, depth);
        schrank.append(rahmen, false);
        Line2D diagonale1 = new Line2D.Double(0, 0, width, depth);
        schrank.append(diagonale1, false);
        Line2D diagonale2 = new Line2D.Double(0, depth, width, 0);
        schrank.append(diagonale2, false);
        return transform(schrank);
    }
}
