import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MOUSEMovementTest extends JButton {
    private static final long serialVersionUID = 1L;
    private volatile int draggedAtX, draggedAtY;

    public MOUSEMovementTest(String text) {
        super(text);
        setDoubleBuffered(false);
        setMargin(new Insets(0, 0, 0, 0));
        setSize(125, 25);
        setPreferredSize(new Dimension(25, 25));

        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                draggedAtX = e.getX();
                draggedAtY = e.getY();
            }
        });

        addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseDragged(MouseEvent e) {
                setLocation(e.getX() - draggedAtX + getLocation().x, e.getY() - draggedAtY + getLocation().y);
                System.out.println(e.getX() + " " + draggedAtX + " " + getLocation().x);
            }
        });
    }

    public static void MouseMovementTester() {
        JFrame frame = new JFrame("DragButton");
        frame.setLayout(null);
        frame.getContentPane().add(new MOUSEMovementTest("Thanks"));
        frame.getContentPane().add(new MOUSEMovementTest("for"));
        frame.getContentPane().add(new MOUSEMovementTest("using!"));
        frame.setSize(300, 300);
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }
}