import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;

/**
 * Ein Tisch, der manipuliert werden kann und sich selbst auf einer Leinwand
 * zeichnet.
 * 
 * @author Claus Albowski
 * @version 2.3 (sept 07)
 */
public class Table extends Furniture {
    private static final long serialVersionUID = 1L;

    /**
     * Erzeuge einen neuen Tisch mit einer Standardfarbe und Standardgroesse an
     * einer Standardposition. (Standardkonstruktor)
     */
    public Table() {
        xPosition = 120;
        yPosition = 50;
        orientation = 0;
        color = Color.red;
        isVisible = false;
        width = 120;
        depth = 100;
    }

    /**
     * Erzeuge einen neuen Tisch.
     */
    public Table(int xPosition, int yPosition, Color color, int orientation, int width, int depth) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.color = color;
        this.currentColor = color; // the default color is set to the initial color
        this.defaultColor = color; // the default color is set to the initial color
        this.orientation = orientation;
        isVisible = false;
        this.width = width;
        this.depth = depth;
        this.defaultWidth = width; // the default width is set to the initial width
        this.defaultDepth = depth; // the default width is set to the initial depth
    }

    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten [ Zum Anzeigen
     * der Attributwerte ueber Inspect muss hier die Sichtbarkeit auf public gesetzt
     * werden. ]
     */
    protected Shape getCurrentFigure() {
        Shape tisch = new Ellipse2D.Double(0, 0, width, depth);
        return transform(tisch);
    }
}
